#!/usr/bin/perl -w

use strict;
use warnings;
use Getopt::Std;
use FileHandle;

sub usage{
  print STDERR "Usage: $0 [-o outfile] tags1.def tags2.def\n";
  exit(1);
}



my %options=();

getopt('o:h',\%options);

$options{h} && usage();

my @label;
my %tag;

my $count=0;
while (<>){
  next if (m/^\s*#/);
  chomp();
  $label[$count]=$_;
  $tag{$_} = $count++;
}


scalar(@label) || die("Uh Oh. No tags defined?");

my $outfile=$options{o} || "-";

open (C,">$outfile") || die;
print C '#include <stdio.h>',"\n";
print C '#include "nalloc.h"',"\n";

for (my $i=0; $i<scalar(@label); $i++){
  print C "int TAG_$label[$i]=$i;\n";
}

for (my $i=0; $i<scalar(@label); $i++){
  print C "void $label[$i](na_node_p,na_slot_t);\n";
}


print C "\nna_func na_jump_table[]={\n";
print C join(",\n", @label);
print C "\n};\n";

close C;




