
#ifndef _BASIS_EQUATION_H
#define _BASIS_EQUATION_H 

#include "oms_types.h"
#include "statearray.h"
#include "sa16_array.h"
#include "signed_set.h"
#include "bitmask.h"
#include "nu_sign.h"
#include "be_struct.h"
#include "ridge_graph.h"

#include "oms_hook.h"
#include "nu_sign.h"
#include "nu_sign_set.h"


be_block_p be_alloc(size_t rows, size_t cols, size_t bases);
void be_fixup(na_node_p node, array_index_t slot); /*NA_FUNC*/
na_node_p be_nalloc(na_node_p node, array_index_t slot, size_t rows, size_t cols, size_t bases);
array_index_t be_bases(be_block_p BE);
array_index_t be_cols(be_block_p BE);
array_index_t be_rows(be_block_p BE);
array_index_t be_bindex(be_block_p BE, array_index_t row, array_index_t col);
array_index_t be_sign(be_block_p BE, array_index_t row, array_index_t col);
void be_set_bindex(be_block_p BE, array_index_t row, array_index_t col, array_index_t val);
void be_set_sign(be_block_p BE, array_index_t row, array_index_t col, array_index_t val);
void be_makelinks(be_block_p be);
void be_dump(be_block_p BE);
nu_sign_t be_update_mask(sarray_p mask_array, nu_sign_t which, array_index_t row, array_index_t col, nu_sign_t sigma);
void be_check_mask(na_node_p global,be_block_p BE, array_index_t row, bitmask_t mask, nu_sign_t sigma, sarray_p chi);
bool be_nonmonotone_row(be_block_p BE, array_index_t elem, nu_sign_t sigma, bitmask_t pmask, bitmask_t nmask, bitmask_t zmask, nu_sign_set_p forced);


#endif /* not defined _BASIS_EQUATION_H */	



