#ifndef _BE_STRUCT_H
#define _BE_STRUCT_H

#include "oms_types.h"
#include "bitmask.h"

typedef struct be_coeff_struct {
#ifdef BE_STORE_SIGN
  array_index_t bindex;		/* basis index */
  array_index_t sign;			/* sign in {+1,-1} */
#else
  signed_index_t sindex;
#endif
  array_index_t prev;			/* linked list */
#ifdef BE_STORE_ROW
  array_index_t row;
#endif
#ifdef BE_STORE_COL
array_index_t col;
#endif
#ifdef BE_STORE_ROW_START
  array_index_t row_start;
#endif  
} be_coeff_t,*be_coeff_p;

/* typedef struct { array_index_t row; array_index_t col; } rc_pair_t; */

#ifdef BE_STORE_SIGN
#define be_bindex_raw(BE,elem) (BE->eqn[elem].bindex)
#define be_sign_raw(BE,elem) (BE->eqn[elem].sign)
#define BE_INVALID_BINDEX -1
#define be_in_use(BE,elem) (BE->eqn[elem].bindex>=0)
#define be_mark_unused(BE,row,col) (BE->eqn[row*(BE->cols)+col].bindex=BE_INVALID_BINDEX)
#else
#define be_bindex_raw(BE,elem) (si_index(BE->eqn[elem].sindex))
#define be_sign_raw(BE,elem) (si_sign(BE->eqn[elem].sindex))
#define BE_INVALID_BINDEX 0
#define be_in_use(BE,elem) (BE->eqn[elem].sindex!=0)
#define be_mark_unused(BE,row,col) (BE->eqn[row*(BE->cols)+col].sindex=BE_INVALID_BINDEX)
#endif

#ifdef BE_STORE_ROW
#define be_row(BE,elem) (BE->eqn[elem].row)
#else
#define be_row(BE,elem) (elem/(BE->cols))
#endif
#ifdef BE_STORE_COL
#define be_col(BE,elem) (BE->eqn[elem].col)
#else
#define be_col(BE,elem) (elem % (BE->cols))
#endif

#ifdef BE_STORE_ROW_START
  #define be_row_start(BE,elem) (BE->eqn[elem].row_start)
#else
  #define be_row_start(BE,elem) (be_row(BE,elem)*be_cols(BE))
#endif

typedef struct be_struct {
  bool initialized;
  int rows,cols,stride,bases;
  array_index_t source,sink,diameter;
  int32_t ones_mask;
  array_index_t *last;
  bitmask_t *row_mask;
  be_coeff_t *eqn;
} be_block_t, *be_block_p;

#endif
