#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "oms_error.h"
#include "oms_opt.h"
#include "profile.h"

#ifdef  HAVE_CONFIG_H
#include "config.h"
#endif
#include "gparams.h"

#ifdef USE_ZRAM
#include <z_par.h>
#endif

extern int zzrval;
int debug_indent=1;

void    oms_fatal(char *funct, char *fmt, ...)
{
  va_list args;
  /*
  ** Display the name of the function that called error
  */
  fprintf(stderr, "%s: ", funct);
  /*
  ** Display the remainder of the message
  */
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  va_end(args);
  fprintf(stderr,"\n\n");
#ifdef USE_DMALLOC
dmalloc_shutdown();
#endif
  abort();
}


void    oms_shutdown(params_p params,char *funct, char *fmt, ...)
{
  va_list args;
  /*
  ** Display the name of the function that called error
  */
  fprintf(stderr, "%s: ", funct);
  /*
  ** Display the remainder of the message
  */
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  va_end(args);
  fprintf(stderr,"\n\n");

#ifdef USE_DMALLOC
dmalloc_shutdown();
#endif
 if(OPT_use_profile){
   prof_dump(params->profile_level);
 }
 exit(0);

}



void    oms_warning(char *funct, char *fmt, ...)
{
  va_list args;
  int i;
  /*
  ** Display the name of the function that called error
  */
  /* this is muy bogus in parallel. What was I thinking? */
  if (0){  
    for (i=0; i<debug_indent; i++){
      fprintf(stderr,ERR_INDENT_STR);
    }
  }
#ifdef USE_ZRAM
  fprintf(stderr, "node %d: %s: ", z_myproc,funct);
#else
  fprintf(stderr, "%s: ", funct);
#endif

  /*
  ** Display the remainder of the message
  */
  va_start(args, fmt);
  vfprintf(stderr, fmt, args);
  va_end(args);
  fprintf(stderr,"\n\n");
}




